proc get_comments {} {
   global brewcomments med

   toplevel .comments
   set w .comments
   wm geometry $w +315+80
   wm title .comments Comments
   label $w.cmts -text "Enter your comments for this brew below." \
      -font $med
   pack $w.cmts -side top -expand n -anchor w
   pack [frame $w.f] -side top
   set w .comments.f

   text $w.t -yscrollcommand "$w.scrolly set" -font $med \
      -background white -foreground black
   scrollbar $w.scrolly -orient v -command "$w.t yview"
   pack $w.scrolly -side right -fill y
   pack $w.t -side left -fill both -expand 1
   ::autoscroll::autoscroll $w.scrolly

   pack $w.t -side top
   set w .comments
   pack [frame $w.endf] -side top -expand y -fill x
   button $w.endf.save -text {Save Changes} -command {
      if {[check_mfcomments] == 0} {
         set brewcomments ""
      } else {
         set brewcomments [.comments.f.t get 0.0 end]
      }
      if {[check_comments]} {
         tk_messageBox -type ok -message "COMMENTS SAVED"
         .mf.comments configure -foreground #d90000
      } else {
         tk_messageBox -type ok -message "COMMENTS CLEARED"
         .mf.comments configure -foreground black
      }
   }
   button $w.endf.dismiss -text {Dismiss} -command { close_comments }
   pack $w.endf.save $w.endf.dismiss -side left -expand y -fill x

   if {[check_comments]} {
      .comments.f.t insert 0.0 $brewcomments
      .mf.comments configure -foreground #d90000
   } else {
      .mf.comments configure -foreground black
   }
}


proc close_comments {} {
destroy .comments 
}


proc newconfig {} {
   global foo hopmethod
   set x [winfo rootx .mf.opts] ; set y [winfo rooty .mf.opts]
   incr y 14
   toplevel .config ; wm geometry .config +$x+$y

   pack [frame .config.hm] -side top -expand y -fill x
   set w .config.hm
   label $w.l -text "Hop calculations use:  "
   radiobutton $w.rager -text Rager -variable hopmethod -value rager
   radiobutton $w.tinseth -text Tinseth -variable hopmethod -value tinseth
   pack $w.l $w.rager $w.tinseth -side left -expand n

   set spl 1
   label .config.spline$spl -text "------------------------------------"
   pack .config.spline$spl -side top

   pack [label .config.smash -text "Mash-related settings" \
         -foreground red] -side top -expand y -fill x

   incr spl
   label .config.spline$spl -text "------------------------------------"
   pack .config.spline$spl -side top

   pack [frame .config.mash] -side top -expand n -anchor w
   set w .config.mash

   label $w.eff -text "Mash Efficiency (%):  "
   entry $w.masheff -width 6 -textvariable masheff \
      -foreground black -background white -font {Times 14 bold} \
      -insertbackground red -insertwidth 3 -selectbackground #eeeeee
   grid $w.eff -row 1 -column 1 -sticky w
   grid $w.masheff -row 1 -column 2 -sticky w

   label $w.bvol -text "Boil Volume (gal):  "
   entry $w.boilvol -width 6 -textvariable boilvol \
      -foreground black -background white -font {Times 14 bold} \
      -insertbackground red -insertwidth 3 -selectbackground #eeeeee
   grid $w.bvol -row 2 -column 1 -sticky w
   grid $w.boilvol -row 2 -column 2 -sticky w

   label $w.bsize -text "Batch Size (gal):  "
   entry $w.batchsize -width 6 -textvariable batchsize \
      -foreground black -background white -font {Times 14 bold} \
      -insertbackground red -insertwidth 3 -selectbackground #eeeeee
   grid $w.bsize -row 3 -column 1 -sticky w
   grid $w.batchsize -row 3 -column 2 -sticky w

   incr spl
   label .config.spline$spl -text "------------------------------------"
   pack .config.spline$spl -side top

   pack [label .config.strikelbl -text "Calculating Strike Temps" \
         -foreground red] -side top -expand y -fill x

   incr spl
   label .config.spline$spl -text "------------------------------------"
   pack .config.spline$spl -side top

   pack [frame .config.strike] -side top -expand n -anchor w
   set w .config.strike

   set idx 1
   label $w.l$idx -text "Specific Heat of Grain:  "
   entry $w.e$idx -width 6 -textvariable sh_grain \
      -foreground black -background white -font {Times 14 bold} \
      -insertbackground red -insertwidth 3 -selectbackground #eeeeee
   grid $w.l$idx -row $idx -column 1 -sticky w
   grid $w.e$idx -row $idx -column 2 -sticky w

   incr idx
   label $w.l$idx -text "Thermal Inertia of Mash Tun:  "
   entry $w.e$idx -width 6 -textvariable ti_tun \
      -foreground black -background white -font {Times 14 bold} \
      -insertbackground red -insertwidth 3 -selectbackground #eeeeee
   grid $w.l$idx -row $idx -column 1 -sticky w
   grid $w.e$idx -row $idx -column 2 -sticky w

   balloonhelp $w.e$idx \
"Use 0 if you pre-heat the mash tun;
Use 0.7 for a 10 gal Rubbermaid cooler (not pre-heated)"

   incr idx
   label $w.l$idx -text "Boil temperature (F):  "
   entry $w.e$idx -width 6 -textvariable boil_temp \
      -foreground black -background white -font {Times 14 bold} \
      -insertbackground red -insertwidth 3 -selectbackground #eeeeee
   grid $w.l$idx -row $idx -column 1 -sticky w
   grid $w.e$idx -row $idx -column 2 -sticky w

   incr idx
   label $w.l$idx -text "Ambient temperature (F):  "
   entry $w.e$idx -width 6 -textvariable ambient_temp \
      -foreground black -background white -font {Times 14 bold} \
      -insertbackground red -insertwidth 3 -selectbackground #eeeeee
   grid $w.l$idx -row $idx -column 1 -sticky w
   grid $w.e$idx -row $idx -column 2 -sticky w
   balloonhelp $w.e$idx "Set on brew day for current ambient temps"

   incr idx
   label $w.l$idx -text "Desired mash temperature (F):  "
   entry $w.e$idx -width 6 -textvariable mashtemp \
      -foreground black -background white -font {Times 14 bold} \
      -insertbackground red -insertwidth 3 -selectbackground #eeeeee
   grid $w.l$idx -row $idx -column 1 -sticky w
   grid $w.e$idx -row $idx -column 2 -sticky w

   incr idx
   label $w.l$idx -text "Desired mash thickness (qts/lb):  "
   entry $w.e$idx -width 6 -textvariable mash_thick \
      -foreground black -background white -font {Times 14 bold} \
      -insertbackground red -insertwidth 3 -selectbackground #eeeeee
   grid $w.l$idx -row $idx -column 1 -sticky w
   grid $w.e$idx -row $idx -column 2 -sticky w
   balloonhelp $w.e$idx \
"A mash thickness of 1.5 should result in the highest extract efficiency,
HOWEVER, like mash temperature, mash thickness also affects the amount of
fermentables (and thus, body in the finished product):  a thinner mash
will result in more fermentables, while a thicker mash will create more
maltodextrins for more body."

   incr spl
   label .config.spline$spl -text "------------------------------------"
   pack .config.spline$spl -side top

   set w .config
   label $w.files1 -text "External configuration files:" -foreground red
   label $w.fonts -text "   Fonts:  edit config.tcl to set"
   label $w.grain -text "   Grain:  edit init/userdata.tcl to add/modify"
   label $w.hops -text "    Hops:   edit init/userdata.tcl to add/modify"
   pack $w.files1 $w.fonts $w.grain $w.hops -side top -expand n -anchor w

   button $w.dismiss -text "Dismiss" -command { destroy .config }
   pack $w.dismiss -side top -expand y -fill x
}

proc gi {p i o} {
   toplevel .convert
   global procname in out
   set procname $p ; set in $i ; set out $o
   set w .convert
   wm geometry .convert +324+52

   label $w.title -text "Conversions:  $in to $out" -font {Times 14 bold}
   grid $w.title -row 1 -column 1 -columnspan 2 -sticky ew ; update
   label $w.sp1 -text "==============================" -font {Times 14 bold}
   grid $w.sp1 -row 2 -column 1 -columnspan 2 -sticky ew ; update

   label $w.inl -text "$in:  " -font {Times 12 bold}
   grid $w.inl -row 3 -column 1 -sticky ew ; update

   entry $w.ine -textvariable inval -width 10 -font {Times 12}
   grid $w.ine -row 3 -column 2 -sticky w ; update

   label $w.outl -text "$out:  " -font {Times 12 bold}
   grid $w.outl -row 4 -column 1 -sticky ew ; update

   label $w.outr -textvariable outval -font {Times 12} -relief sunken -width 10
   grid $w.outr -row 4 -column 2 -sticky w ; update

   button $w.calc -text Convert    -font {Times 12 bold} \
      -command {set outval [$procname $inval]}
   grid $w.calc -row 5 -column 1
   button $w.ret -text Done -command {
      set inval ""
      set outval ""
      destroy .convert
      return
   }
   grid $w.ret -row 5 -column 2
}


proc CtoF {degc}                { return [expr {(1.8 * $degc) + 32.0}] }
proc FtoC {degf}                { return [expr {($degf - 32)/1.8}] }
proc lbs_to_kg {lbs}            { return [expr {$lbs * 0.453592}] }
proc kg_to_lbs {kgs}            { return [expr {$kgs * 2.204623}] }
proc gal_to_ltr {gals}          { return [expr {$gals * 3.785412}] }
proc ltr_to_gal {liters}        { return [expr {$liters * 0.264272}] }
proc qts_to_ltr {qts}           { return [expr {$qts * 0.946353}] }
proc ltr_to_qts {liters}        { return [expr {$liters * 1.056688}] }
proc SG_to_Plato {SG}           { return [expr {(1000*($SG - 1))/4}] }
proc Plato_to_SG {degP}         {
   return [format %1.04f [expr {4.000*($degP/1000.000) + 1.000}]]
}


proc reformulate {} {
   global med stepno userme userbs batchsize masheff

   set stepno 1

   toplevel .reformulate
   set w .reformulate
   wm geometry $w +315+80
   pack [frame $w.f] -side top
   set w .reformulate.f

   text $w.t -yscrollcommand "$w.scrolly set" -font $med \
      -background white -foreground black
   scrollbar $w.scrolly -orient v -command "$w.t yview"
   pack $w.scrolly -side right -fill y
   pack $w.t -side left -fill both -expand 1
   ::autoscroll::autoscroll $w.scrolly

   pack $w.t -side top

   $w.t insert end "Brewer's Recipe Reformulator\n\n"

   $w.t insert end \
"You will need the following information for the original brew:
   1) The complete grain bill and hop schedule
   2) The original gravity (either specific gravity or deg. P)
   3) The post-boil volume (gallons)\n\n"

   set userme $masheff
   set userbs $batchsize

   $w.t insert end \
"To begin, enter the full grain bill and hop schedule for the beer
you want to re-scale.  Enter the appropriate mash efficiency (%yield)
and final volume information for the source batch in the configuration
section.  Make sure the calculated values match the source.\n\n"

   $w.t insert end "Enter YOUR brewery's typical %yield here:  "
   entry $w.euserme -textvariable userme
   $w.t window create end -window $w.euserme
   $w.t insert end "\n"
   $w.t insert end "Enter your desired batch size here:  "
   entry $w.euserbs -textvariable userbs
   $w.t window create end -window $w.euserbs
   $w.t insert end "\n\n"

   $w.t insert end "After you finish these steps, press \[OK] below.\n\n"

   pack [frame $w.bot] -side top -expand y -fill x
   set w $w.bot

   button $w.ok -text "OK" -command rf_next
   button $w.dismiss -text "Dismiss" -command { destroy .reformulate }
   pack $w.ok $w.dismiss -side left -expand y -fill x
}

proc rf_next {} {
   global stepno

   if {$stepno == 1} {
      rf_step2
   } elseif {$stepno == 2} {
      rf_step3
   }
}


proc rf_step2 {} {
   global grains Grain med stepno userme userbs masheff batchsize

   incr stepno
   set w .reformulate.f.t
   $w delete 0.0 end
   $w insert end \
      "New values for the grain bill for $userbs gal at $userme %yield:\n\n"

   foreach idx $Grain() {
      if {[grain_valid $idx]} {
         set name $Grain($idx:name)
         set ppg [lindex $grains($name) 0]
         if {$ppg == 0} { continue }
         set sgp $Grain($idx:sgpartial)

         set nw [partialweight $ppg $sgp $userbs $userme]
         set newweight($idx)  $nw

         set newlb [expr {int($nw)}]
         set newweight($idx:lb) $newlb
         set newoz [format %0.1f [expr {(round(160 * ($nw - $newlb)))/10.0}]]
         set newweight($idx:oz) $newoz
         $w insert end "$idx/$name:  $newlb lbs, $newoz oz)\n\n"
         set Grain($idx:newlb) $newlb
         set Grain($idx:newoz) $newoz
      }
   }
   $w insert end "Would you like me to apply these now?  "
   button $w.insyes -text YES -command {
      foreach idx $Grain() {
         if {[grain_valid $idx]} {
            set Grain($idx:lb) $Grain($idx:newlb)
            set Grain($idx:oz) $Grain($idx:newoz)
         }
      }
      set batchsize $userbs
      set masheff $userme
      set newvalstatus DONE
      calc_grain
   }
   $w window create end -window $w.insyes
   $w insert end "  "
   button $w.insno  -text NO  -command { set newvalstatus OK }
   $w window create end -window $w.insno
   $w insert end "\n"
   label $w.insstatus -textvariable newvalstatus
   $w window create end -window $w.insstatus
   $w insert end "\n\n"

   $w insert end "Click on \[OK] when you are ready to move on\n"
}

proc rf_step3 {} {
   global stepno
   incr stepno

   set w .reformulate.f.t
   $w delete 0.0 end
   $w insert end \
"Ok, from this point, you can move to the hops.  All of the hop
calculations are done from the hop schedule section.\n
TAKE NOTES:  You will be using the information calculated for the
original source batch for IBUs.\n
First, to the left of the HOPS grid, click on the AMT button to select
calculating the amount given the IBUs.\n
Adjust the hop variety and alpha acid information as needed for each
hop addition to match what you have.  Make sure the IBU counts match
the ones calculated for the source batch.\n
Click on the \[Calc] button to calculate the new amounts for each hop
addition.\n
And that\'s it!\n\n"
}

